#ifndef EFL_GFX_GRADIENT_EO_HH
#define EFL_GFX_GRADIENT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_gfx_gradient.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace gfx { 
struct Gradient;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::gfx::Gradient> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace gfx { 
struct Gradient {
   ::efl::eolian::return_traits<Efl_Gfx_Gradient_Spread>::type spread_get() const;
   ::efl::eolian::return_traits<void>::type spread_set( ::efl::eolian::in_traits<Efl_Gfx_Gradient_Spread>::type s) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_GFX_GRADIENT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::gfx::Gradient() const;
   operator ::efl::gfx::Gradient&();
   operator ::efl::gfx::Gradient const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Gradient> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Gradient const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace gfx { 
struct Gradient : ::efl::eo::concrete
{
   explicit Gradient( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Gradient(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Gradient(Gradient const& other) = default;
   Gradient(Gradient&& other) = default;
   Gradient& operator=(Gradient const& other) = default;
   Gradient& operator=(Gradient&& other) = default;
   Gradient()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Gradient( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Gradient(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<Efl_Gfx_Gradient_Spread>::type spread_get() const;
   ::efl::eolian::return_traits<void>::type spread_set( ::efl::eolian::in_traits<Efl_Gfx_Gradient_Spread>::type s) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_GFX_GRADIENT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Gradient> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Gradient const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Gradient) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Gradient>::value, "");
} } 
#include "efl_gfx_gradient.eo.impl.hh"
#endif
